﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class Form1
   Private moMap As WinformsMap
   Private moSqlLayer As MsSql2008FeatureLayer
   Private WithEvents moTrackOverlay As TrackInteractiveOverlay
   Private meMouseButton As MapMouseButton
   Private moSelectedFeature As Feature
   Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
      Dim oLayerOverlay As New LayerOverlay

      moMap = WinformsMap1
      moMap.MapUnit = GeographyUnit.Meter
      moMap.MinimumScale = 0

      Dim oBuilder As New System.Data.SqlClient.SqlConnectionStringBuilder
      With oBuilder
         .DataSource = "(local)\GEOSUITE"
         .IntegratedSecurity = True
         .InitialCatalog = "ForestersDesktop_Empty"
      End With

      '***** Connect to a table that is a synonym, which references
      '***** a table in another database
      moSqlLayer = New MsSql2008FeatureLayer(oBuilder.ToString, "State", "StateId", 102003)
      moSqlLayer.CustomGeometryColumnName = "shape"
      moSqlLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 2)
      moSqlLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      moSqlLayer.Name = "States"
      moSqlLayer.Open()

      '***** Save a feature to use in demonstrating selection
      moSelectedFeature = moSqlLayer.QueryTools.GetFeatureById("1", ReturningColumnsType.AllColumns)
      Dim oExtent As RectangleShape = moSelectedFeature.GetBoundingBox
      oExtent.ScaleUp(200)
      moMap.CurrentExtent = oExtent

      '***** Make a way to draw moSelectedFeature
      Dim oInMemoryFeatureLayer As New InMemoryFeatureLayer()
      With oInMemoryFeatureLayer
         .ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.LightYellow, GeoColor.SimpleColors.Blue, 2)
         .ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
         .InternalFeatures.Add(moSelectedFeature)
      End With

      oLayerOverlay.Layers.Add(moSqlLayer)
      oLayerOverlay.Layers.Add(oInMemoryFeatureLayer)
      moMap.Overlays.Add(oLayerOverlay)

      WinformsMap1.Refresh()

   End Sub

   Private Sub btnSelecteIntersecting_Click(sender As Object, e As EventArgs) Handles btnSelecteIntersecting.Click
      moSqlLayer.Open()
      Dim oSelectedFeatures As Collection(Of Feature) = moSqlLayer.QueryTools.GetFeaturesIntersecting(moSelectedFeature, ReturningColumnsType.AllColumns)
      MessageBox.Show("Successfully selected " + oSelectedFeatures.Count.ToString + " intesecting features")
   End Sub

   Private Sub btnSelectDisjoint_Click(sender As Object, e As EventArgs) Handles btnSelectDisjoint.Click
      moSqlLayer.Open()
      Try
         Dim oSelectedFeatures As Collection(Of Feature) = moSqlLayer.QueryTools.GetFeaturesDisjointed(moSelectedFeature, ReturningColumnsType.AllColumns)
         MessageBox.Show("Successfully selected " + oSelectedFeatures.Count.ToString + " disjoint features")
      Catch ex As Exception
         MessageBox.Show("Error: " & ex.Message)
      End Try
   End Sub
End Class
